﻿@addTagHelper *, Microsoft.AspNetCore.Mvc.TagHelpers
@model CyberaniumModels.Compliance
@if (Model.Id > 0)
{
    <style>
        td .plusIcon {
            width: 20px;
            height: 20px;
            display: block;
            background: #00a3a1;
            position: relative;
            cursor: pointer;
        }

            td .plusIcon::before {
                content: "";
                width: 2px;
                height: 12px;
                background: #fff;
                position: absolute;
                top: 4px;
                left: 50%;
                margin-left: -1px;
            }

            td .plusIcon::after {
                content: "";
                width: 12px;
                height: 2px;
                background: #fff;
                position: absolute;
                left: 4px;
                top: 50%;
                margin-top: -1px;
            }

        td .minusIcon {
            width: 20px;
            height: 20px;
            display: block;
            background: #f00;
            position: relative;
            cursor: pointer;
        }

            td .minusIcon::after {
                content: "";
                width: 12px;
                height: 2px;
                background: #fff;
                position: absolute;
                left: 4px;
                top: 50%;
                margin-top: -1px;
            }
    </style>
    <script>
        function AddMoreQuestionnaire() {
            var sn = Number($('#tbody tr:last td:eq(0) input').val());
            $('#tbody').append('<tr>' +
                '<td><input type="number" class="form-control" min="1" value="' + (sn + 1) + '" onchange="ValidateNumber(this)" /></td>' +
                '<td hidden><input type="number" class="form-control" value="0" /></td>' +
                '<td><input type="text" class="form-control" /></td>' +
                '<td><span class="minusIcon" value="-" onclick="$(this).closest(`tr`).remove();Orderring();"></span></td>' +
                '</tr>');
        }
        function Orderring(sn = 1) {
            $('#tbody tr').each((i, tr) => {
                $(tr).find('td:eq(0) input').val(sn + i);
            })
        }
        function ValidateNumber(input) {
            var number = Number($(input).val());
            if (number <= 0) {
                $(input).val('');
                toastr.warning('Number should be greater than 0');
            }
        }
        function SubmitQuestionnaire() {
            $('#preloader').show();
            var questionnaireXML = [];
            var eventType = Number($('#EventType').val());
            var conCatId = Number($('#ControlCategory').val());
            if (conCatId > 0) {
                $('#tbody tr').each((i, tr) => {
                    var orderNo = Number($(tr).find('td:eq(0) input').val());
                    var id = Number($(tr).find('td:eq(1) input').val());
                    var questionnaire = $(tr).find('td:eq(2) input').val();
                    questionnaireXML[i] = {
                        Id: id,
                        OrderNo: orderNo,
                        Questionnaire: questionnaire
                    }
                })
                var xml = JSON.stringify(questionnaireXML);
                $.ajax({
                    url: '/ApplicationManagement/Compliance/SubmitCompliance',
                    type: 'post',
                    data: { EventType: eventType, ControlCategory: conCatId, QuestionnaireXML: xml },
                    success: res => {
                        if (res.isSuccess) {
                            $('#preloader').hide();
                            $('#spn' + conCatId).click();
                            $(".orgmap li a.edit_btn").removeClass("active");
                            toastr.success(eventType > 0 ? 'Updated successfully' : 'Saved successfully');
                        } else {
                            toastr.warning('Something went wrong!');
                        }
                    }
                })
                $('#form').submit();
            } else {
                toastr.warning('Please select a control category!');
            }
        }
    </script>
    <div class="table_control">
        <input type="hidden" asp-for="ControlCategory" />
        <input type="hidden" asp-for="EventType" value="@(Model.Id>1?1:0)" />
        <table class="table">
            <thead>
                <tr>
                    <th width="90">Order No.</th>
                    <th>Questionnaire</th>
                    <th width="70">Action</th>
                </tr>
            </thead>
            <tbody id="tbody">
                @if (Model.Id > 1)
                {
                    int sn = 0;
                    foreach (var item in Model.ComplianceList.OrderBy(x => x.OrderNo).ToList())
                    {
                        <tr>
                            <td><input type="number" class="form-control" min="1" value="@item.OrderNo" onchange="ValidateNumber(this)" /></td>
                            <td hidden><input type="number" class="form-control" value="@item.Id" /></td>
                            <td><input type="text" class="form-control" value="@item.Query" /></td>
                            <td>@(sn>0?Html.Raw("<span class='minusIcon' value='-' onclick='$(this).closest(`tr`).remove(); Orderring();'></span>") :Html.Raw("<span class='plusIcon' onclick='AddMoreQuestionnaire()'></span>"))</td>
                        </tr>
                        sn++;
                    }
                }
                else
                {
                    <tr>
                        <td><input type="number" class="form-control" min="1" value="1" onchange="ValidateNumber(this)" /></td>
                        <td hidden><input type="number" class="form-control" value="0" /></td>
                        <td><input type="text" class="form-control" /></td>
                        <td><span class="plusIcon" onclick="AddMoreQuestionnaire()"></span></td>
                    </tr>
                }
            </tbody>
        </table>
    </div>
    <div class="row">
        <div class="col-md-12 col-sm-6 col-xs-12">
            <div class="back_btn">
                <div class="back_btn_in">
                    <input type="button" id="btnBack" value="Cancel" onclick="$.get('/ApplicationManagement/Compliance/Index', res => $('#ajaxresult').html(res))">
                </div>
            </div>
            <div class="submitbtn">
                <input type="button" id="btnsubmit" name="Submit" value="Submit" onclick="SubmitQuestionnaire()">
            </div>
        </div>
    </div>
}
else
{
    <style>
        .table tr th {
            text-align: center;
        }

        .table tr td {
            text-align: center;
        }
    </style>
    <script>
        function RemoveQuestionnaire(id, conCatId) {
            Swal.fire({
                title: 'Are you sure?',
                text: 'You want to delete',
                showCancelButton: true,
                confirmButtonText: 'Delete',
            }).then(res => {
                if (res.isConfirmed) {
                    $('#preloader').show();
                    $.get('/ApplicationManagement/Compliance/BlockDeleteCompliance', { Id: id }, res => {
                        if (res.isSuccess) {
                            $('#preloader').hide();
                            toastr.success('Deleted successfully');
                            $.get('/ApplicationManagement/Compliance/Questionnaire', { conCatId: conCatId }, res => $('#divQuestionnaire').html(res));
                        } else {
                            toastr.warning('Something went wrong!');
                        }
                    })
                }
            })
        }
        function SetIsPrimary(input, id, conCatId) {
            Swal.fire({
                title: 'Are you sure?',
                text: 'You want to set as primary this',
                showCancelButton: true,
                confirmButtonText: 'Confirm',
            }).then(res => {
                if (res.isConfirmed) {
                    $('#preloader').show();
                    $.get('/ApplicationManagement/Compliance/SetIsPrimary', { Id: id }, res => {
                        if (res.isSuccess) {
                            $('#preloader').hide();
                            toastr.success('Set successfully');
                            $('input[type="checkbox"]').prop('checked', false);
                            $(input).prop('checked', true);
                        } else {
                            toastr.warning('something went wrong!');
                        }
                    })
                } else {
                    $(input).prop('checked', false);
                }
            })
        }
    </script>
    <div class="table_control">
        <table class="table">
            <thead>
                <tr>
                    <th width="80">SN</th>
                    <th width="80">Primary</th>
                    <th style="text-align:left">Questionnaire</th>
                    <th width="80">OrderNo</th>
                    <th width="80">Action</th>
                </tr>
            </thead>
            <tbody>
                @if (Model.ComplianceList.Count > 0)
                {
                    int sn = 0;
                    foreach (var item in Model.ComplianceList.OrderBy(x => x.OrderNo).ToList())
                    {
                        <tr style="text-align:center">
                            <td>@(++sn)</td>
                            <td><input type="checkbox" onclick="SetIsPrimary(this,'@item.Id', '@item.ControlCategory')" @(item.IsPrimary ? "checked" : "") /></td>
                            <td style="text-align:left">@item.Query</td>
                            <td>@item.OrderNo</td>
                            <td><a href="#" onclick="RemoveQuestionnaire('@item.Id', '@item.ControlCategory')"><i class="fa fa-trash text-danger"></i></a></td>
                        </tr>
                    }
                }
                else
                {
                    <tr>
                        <td colspan="4" class="text-center">No record found...</td>
                    </tr>
                }
            </tbody>
        </table>
    </div>
}
